config/routes.rb
Rails.application.routes.draw do
    #https://github.com/plataformatec/devise/wiki/How-To:-Define-a-different-root-route-for-logged-in-out-users
    devise_for :cashiers, only: [:sessions]
    devise_for :admins, only: [:sessions]
    resources :products
    resources :orders
    resources :cashiers
    post 'orders/summary', to: "orders#summary"
    
    root 'publics#index'
    get "/products/:id", to: "products#deactivate"
    # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/admin.rb
class Admin < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :rememberable, :trackable, :validatable
         # :recoverable, :registerable
  
  has_many :products
  has_many :cashiers
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/cashier.rb
class Cashier < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :rememberable, :trackable, :validatable
         # :recoverable, :registerable
    belongs_to :admin
end

app/models/order.rb
class Order < ApplicationRecord
  belongs_to :cashier
  has_many :order_lines
  
  accepts_nested_attributes_for :order_lines , reject_if: :all_blank, allow_destroy: true
end

app/models/order_line.rb
class OrderLine < ApplicationRecord
  belongs_to :product
  belongs_to :order
end

app/models/product.rb
class Product < ApplicationRecord
    default_scope { where(status: true) }
    belongs_to :admin
    has_many :order_lines
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
    protect_from_forgery with: :exception
    # https://github.com/plataformatec/devise/wiki/How-To:-redirect-to-a-specific-page-on-successful-sign-in
    def after_sign_in_path_for(resource)
        if resource.is_a?(Admin)
          products_path
        elsif resource.is_a?(Cashier)
          orders_path 
        end
    end
    
end

app/controllers/cashiers_controller.rb
class CashiersController < ApplicationController
    # before_action :authenticate_admin! 
    def new
        @cashier = Cashier.new
    end
    def create
        @cashier = Cashier.new(cashier_params)
        @cashier.admin = current_admin
        @cashier.inspect
        @cashier.save
        
        redirect_to @cashier
    end
    def show
        @cashier = Cashier.find(params[:id])
        if @cashier.admin != current_admin
            redirect_to cashiers_path
        elsif @cashier.admin == nil
            redirect_to cashiers_path
        end
        
    end
    def index
        @cashiers = Cashier.all
    end
    def edit
        @cashier = Cashier.find(params[:id])
    end
    def update
        @cashier = Cashier.find(params[:id])
        @cashier.update(product_params)
        @cashier.save
        redirect_to cashiers_path
    end
    def destroy
        @cashier = Cashier.find(params[:id])
        @cashier.destroy
        redirect_to cashiers_path
    end
    
    private
        def cashier_params
            params.require(:cashier).permit!
        end
end

app/controllers/orders_controller.rb
class OrdersController < ApplicationController
    #before_action :authenticate_cashier! 
    
    def new
        @order = Order.new
    end
    
    def summary
        raise order_params.inspect
        @order = Order.new(order_params)
        raise @order.order_lines[0].product.price.inspect
        i=0
        @order.order_lines.each do |o|
            i += o.product.price * o.quantity
        end
        @order.total_price = i
        
    end
    
    def create
        @order = Order.new(order_params)
        @order.cashier = current_cashier
        @order.save
    
        redirect_to @order
    end
    
    def index
        @orders = Order.all
    end
    
    def edit
        @order = Order.find(params[:id])
        if @order.cashier != current_cashier
            redirect_to orders_path
        end
    end
    
    def update
        @order = Order.find(params[:id])
        @order.update(order_params)
        @order.save
        
        redirect_to order_path
    end
    
    def destroy
        @order = Order.find(params[:id])
        @order.destroy
        
        redirect_to orders_path
    end

    def show
        id = params[:id]
        @order = Order.find(id)
    end
    
    
    private
        def order_params
            params.require(:order).permit!
        end
end

app/controllers/products_controller.rb
class ProductsController < ApplicationController
    # before_action :authenticate_admin! 
    def new
        @product = Product.new
    end
    def create
        @product = Product.new(product_params)
        @product.admin = current_admin
        @product.save
        
        redirect_to @product
    end
    def show
        @product = Product.find(params[:id])
        
    end
    def index
        @products = Product.all
    end
    def edit
        @product = Product.find(params[:id])
        if @product.admin != current_admin
            @product = Product.find(params[:id])
        elsif @product.admin == nil
            @product = Product.find(params[:id])
        end
    end
    def update
        @product = Product.find(params[:id])
        @product.update(product_params)
        @product.save
        redirect_to @product
    end
    
    def destroy
        @product = Product.find(params[:id])
        @product.destroy
        redirect_to @product
    end
    
    def deactivate
        @product = Product.find(params[:id])
        @product.status = false
    end
    
    
    private
        def product_params
            params.require(:product).permit(:title, :price, :status)
        end
end

app/controllers/publics_controller.rb
class PublicsController < ApplicationController
    def index
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/cashiers_helper.rb
module CashiersHelper
end

app/helpers/orders_helper.rb
module OrdersHelper
end

app/helpers/products_helper.rb
module ProductsHelper
end

app/helpers/publics_helper.rb
module PublicsHelper
end

app/views/admins/shared/_links.html.erb
<%- if controller_name != 'sessions' %>
  <%= link_to "Log in", new_session_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.registerable? && controller_name != 'registrations' %>
  <%= link_to "Sign up", new_registration_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.recoverable? && controller_name != 'passwords' && controller_name != 'registrations' %>
  <%= link_to "Forgot your password?", new_password_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.confirmable? && controller_name != 'confirmations' %>
  <%= link_to "Didn't receive confirmation instructions?", new_confirmation_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.lockable? && resource_class.unlock_strategy_enabled?(:email) && controller_name != 'unlocks' %>
  <%= link_to "Didn't receive unlock instructions?", new_unlock_path(resource_name) %><br />
<% end -%>

<%- if devise_mapping.omniauthable? %>
  <%- resource_class.omniauth_providers.each do |provider| %>
    <%= link_to "Sign in with #{OmniAuth::Utils.camelize(provider)}", omniauth_authorize_path(resource_name, provider) %><br />
  <% end -%>
<% end -%>

app/views/layouts/_navbar.html.erb
<!-- Latest compiled and minified JavaScript -->
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa" crossorigin="anonymous"></script>
<div class="nav navbar-default navbar-fixed-top">
	<div class="container">
		<div class="navbar-header">
			<button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#example">
			<span class="sr-only">Togggle Navigation</span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			</button>
			<% if admin_signed_in? %>
        <a class="navbar-brand" href="https://beta-pos-system-miggyrodri.c9users.io/products">POS System</a>
      <% elsif cashier_signed_in? %>
  			<a class="navbar-brand" href="https://beta-pos-system-miggyrodri.c9users.io/orders">POS System</a>
  		<% else %>
  		  <a class="navbar-brand" href="/">POS System</a>
  		<% end %>
		</div> 
		<div class="collapse navbar-collapse" id="example">
			<ul class="nav navbar-nav">
			  <% if admin_signed_in? %>
				<li class="dropdown">
          <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Cashiers<span class="caret"></span></a>
          <ul class="dropdown-menu">
            <li><a><%= link_to "Create Cashier", new_cashier_path %></a></li>
            <li><a><%= link_to "View Cashiers", cashiers_path%></a></li>
          </ul>
        </li>
        <li class="dropdown">
          <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Products<span class="caret"></span></a>
          <ul class="dropdown-menu">
            <li><a><%= link_to "New Product", new_product_path %></a></li>
            <li><a><%= link_to "View Products", products_path%></a></li>
          </ul>
        </li>
        <% elsif cashier_signed_in? %>
        <li class="dropdown">
          <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Products<span class="caret"></span></a>
          <ul class="dropdown-menu">
            <li><a><%= link_to "New Order", new_order_path %></a></li>
            <li><a><%= link_to "View Orders", orders_path%></a></li>
          </ul>
        </li>
        <% end %>
			</ul>
		    <p class="navbar-text pull-right">
            <% if admin_signed_in? %>
              Logged in as <strong><%= current_admin.email %></strong>.
              <%= link_to "Logout", destroy_admin_session_path, method: :delete, :class => 'navbar-link'  %>
            <% elsif cashier_signed_in? %>
              Logged in as <strong><%= current_cashier.email %></strong>
              <%= link_to "Logout", destroy_cashier_session_path, method: :delete, :class => 'navbar-link' %>
            <% else %>
              <%= link_to "Login", new_admin_session_path, :class => 'navbar-link'  %>
            <% end %>
        </p>
		</div>
	</div>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Workspace</title>
    <%= csrf_meta_tags %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= render 'layouts/navbar' %>
    
    <div class="container" style="padding-top: 60px">
      <% if notice %>
        <p class="alert alert-success"><%= notice %></p>
      <% end %>
      <% if alert %>
        <p class="alert alert-danger"><%= alert %></p>
      <% end %>
      <%= yield %>
    </div>
  </body>
</html>

app/views/products/_form.html.erb
<%= simple_form_for @product do |f| %>
    <p>
        <%= f.input :title %>
    </p>
    <p>
        <%= f.input :price %>
    </p>
    <p>
        <%= f.input :status, :label => "Active?" %>
    </p>
    <%= f.button :submit %>
<% end %>

app/views/products/edit.html.erb
<div class="container">
	<div class="page-header">
		<h1 class="text-center">Edit Product no.<%= @product.id %></h1>
	</div>
</div>
<div class="container">
	<%= render 'products/form' %>	
</div>

app/views/products/home.html.erb
<div class="container">
  <div class="row">
    <div class="col-md-6">
      <h2>Log in for Cashier</h2>

      <%= form_for :cashier, url: new_session_path(:cashier) do |f| %>
        <div class="field">
          <%= f.label :email %><br>
          <%= f.email_field :email, autofocus: true %>
        </div>
      
        <div class="field">
          <%= f.label :password %><br />
          <%= f.password_field :password, autocomplete: "off" %>
        </div>
      
        <div class="actions">
          <%= f.submit "Log in" %>
        </div>
      <% end %>
    </div>
    <div class="col-md-6">
      <h2>Log in for Admin</h2>
       <%= form_for :admin, url: new_session_path(:admin) do |f| %>
        <div class="field">
          <%= f.label :email %><br />
          <%= f.email_field :email, autofocus: true %>
        </div>
      
        <div class="field">
          <%= f.label :password %><br />
          <%= f.password_field :password, autocomplete: "off" %>
        </div>
      
        <div class="actions">
          <%= f.submit "Log in" %>
        </div>
      <% end %>
    </div>
  </div>
  
</div>

<h2>Responsive "Meet The Team" Section</h2>
<p>Resize the browser window to see the effect.</p>
<br>

<div class="row">
  <div class="column">
    <div class="card">
      <img src="/w3images/team1.jpg" alt="Jane" style="width:100%">
      <div class="container">
        <h2>Jane Doe</h2>
        <p class="title">CEO & Founder</p>
        <p>Some text that describes me lorem ipsum ipsum lorem.</p>
        <p>example@example.com</p>
        <p><button class="button">Contact</button></p>
      </div>
    </div>
  </div>

  <div class="column">
    <div class="card">
      <img src="/w3images/team2.jpg" alt="Mike" style="width:100%">
      <div class="container">
        <h2>Mike Ross</h2>
        <p class="title">Art Director</p>
        <p>Some text that describes me lorem ipsum ipsum lorem.</p>
        <p>example@example.com</p>
        <p><button class="button">Contact</button></p>
      </div>
    </div>
  </div>
  <div class="column">
    <div class="card">
      <img src="/w3images/team3.jpg" alt="John" style="width:100%">
      <div class="container">
        <h2>John Doe</h2>
        <p class="title">Designer</p>
        <p>Some text that describes me lorem ipsum ipsum lorem.</p>
        <p>example@example.com</p>
        <p><button class="button">Contact</button></p>
      </div>
    </div>
  </div>
</div>

app/views/products/index.html.erb
<div class="container">
	<div class="page-header">
		<h1 class="text-center">Products</h1>
	</div>
</div>
<div class="container">
    <table class="table table-striped">
    <tr><th>ID</th><th>Title</th><th>Content</th><th>Status</th><th>Creator</th><th>Actions</th></tr>
    <% @products.each do |p| %>
        <tr>
            <td><%= p.id %></td><td><%= p.title %></td><td><%= p.price %></td>
            <td><%= if p.status == true then "Active" else "Inactive" end%></td>
            <td> <%= if p.admin then p.admin.email else 'Anonymous' end%> </td>
            <td><%= link_to "Show Product Details", product_path(p) %></td>
            <td><%= link_to "Deactivate", product_path(p), method: :deactivate, data: {confirm: "Are you sure?"} %></td><br>
        </tr>
    <% end %>
    </table> 
</div>

app/views/products/new.html.erb
<div class="container">
	<div class="page-header">
		<h1 class="text-center">New Product</h1>
	</div>
</div>
<div class="container">
	<%= render 'products/form' %>	
</div>

app/views/products/show.html.erb
<div class="container">
    <div class="row">
        <div class="col-md-4">
            <img src="https://encrypted-tbn0.gstatic.com/images?q=tbn:ANd9GcQHzN_qIJdZAEpfLkJj1mdFG8qbe6Bonaz4tkQs8l-S8onkWXNr" style="padding-top: 36px">
            <h1><%= @product.title %></h1>
            <h4 style="line-height:30%"><font color="gray">Item No. <%= @product.id %></font></h4>
            <h4 style="line-height:30%"><font color="gray">by <%= if @product.admin then @product.admin.email else "Anonymous" end %></font></h4>
        </div>
        <div class="col-md-8">
            <h3 style="padding-top: 36px">Description</h3>
            <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Fugit, reprehenderit, debitis quibusdam libero fuga ex saepe explicabo dolor error officiis sit iusto nostrum sapiente suscipit id eaque blanditiis dignissimos? Nesciunt. Lorem ipsum dolor sit amet, consectetur adipisicing elit. Reiciendis, quidem, consequatur doloribus harum tenetur ex delectus nostrum consequuntur unde dolor nam ipsam. Quam minima libero officiis necessitatibus nihil at aperiam.</p>
            <h3 style="line-height:10%">Price: <font color="gray"><%= @product.price %>php</font></h3>
            <h3 style="line-height:10%">Status: <font color="gray"><%= if @product.status == true then 'Active' else 'Inactive' end %></font></h3>
        </div>
    </div>
    <hr>
    <%= link_to "Edit Product", edit_product_path(@product), class: "btn btn-default" %>
    <%= link_to "Delete", product_path, method: :delete, data: {confirm: "Are you sure?"}, class: "btn btn-default" %>
    <hr>
</div>

app/views/publics/home.html.erb
<h1>Home</h1>
<div class="container">
    <div class="row">
        <div class="col-md-12">
            <div id="my-slider" class="carousel slide" data-ride="carousel">
                <!--Indicators dot nov-->
                <ol class="carousel-indicators">
                    <li data-target="#my-slider" data-slide-to="0" class="active"></li>
                    <li data-target="#my-slider" data-slide-to="1"></li>
                </ol>
                <!--wrapper for slides-->
                <div class="carousel-inner" role="listbox">
                    <div class="item active">
                        <img src="https://cdn.pixabay.com/photo/2017/03/10/15/15/lime-2133091_960_720.jpg" alt="limes" />
                        <div class="carousel-caption">
                            <h1>Limes</h1>
                        </div>
                    </div>
                    <div class="item">
                        <img src="https://cdn.pixabay.com/photo/2017/06/21/13/37/lizard-2427248_960_720.jpg" alt="lizard" />
                        <div class="carousel-caption">
                            <h1>Lizard</h1>
                        </div>
                    </div>
                </div>
                <a class="left carousel-control" href="#my-slider" role="button" data-slide="prev">
                    <span class="glyphicon glyphicon-chevron-left" aria-hidden="true"></span>
                    <span class="sr-only">Previous</span>
                </a>
                <a class="right carousel-control" href="#my-slider" role="button" data-slide="next">
                    <span class="glyphicon glyphicon-chevron-right" aria-hidden="true"></span>
                    <span class="sr-only">Previous</span>
                </a>
            </div>
        </div>
    </div>
</div>

<div class="container">
    <table class="table table-striped">
    <tr><td align="center"><strong>Cashier</strong></th><td align="center"><strong>Product</strong></th></tr>
        <tr>
            <td align="center"><%= link_to "Create Cashier", new_cashier_path %></td>
            <td align="center"><%= link_to "Create Product", new_product_path %></td>
        </tr>
        <tr>
            <td align="center"><%= link_to "View Cashiers", cashiers_path%></td>
            <td align="center"><%= link_to "View Products", products_path%></td>
        </tr>
    </table> 
</div>

app/views/publics/index.html.erb
<div class="container">
  <div class="row">
    <div class="col-md-6">
      <h2>Log in for Cashier</h2>

      <%= form_for :cashier, url: new_session_path(:cashier) do |f| %>
        <div class="field">
          <%= f.label :email %><br>
          <%= f.email_field :email, autofocus: true %>
        </div>
      
        <div class="field">
          <%= f.label :password %><br />
          <%= f.password_field :password, autocomplete: "off" %>
        </div>
      
        <div class="actions">
          <%= f.submit "Log in" %>
        </div>
      <% end %>
    </div>
    <div class="col-md-6">
      <h2>Log in for Admin</h2>
       <%= form_for :admin, url: new_session_path(:admin) do |f| %>
        <div class="field">
          <%= f.label :email %><br />
          <%= f.email_field :email, autofocus: true %>
        </div>
      
        <div class="field">
          <%= f.label :password %><br />
          <%= f.password_field :password, autocomplete: "off" %>
        </div>
      
        <div class="actions">
          <%= f.submit "Log in" %>
        </div>
      <% end %>
    </div>
  </div>
</div>